package com.wuban.tron.explore.entity.example;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 合约事件 查询条件example类
 * @author sky
 * @date 2020-12-03
 */
public class ContractEventExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ContractEventExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

	        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria)this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria)this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria)this;
        }
		
		public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria)this;
        }
			
	            public Criteria andCallerContractAddressIsNull() {
            addCriterion("caller_contract_address is null");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressIsNotNull() {
            addCriterion("caller_contract_address is not null");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressEqualTo(String value) {
            addCriterion("caller_contract_address =", value, "callerContractAddress");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressNotEqualTo(String value) {
            addCriterion("caller_contract_address <>", value, "callerContractAddress");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressIn(List<String> values) {
            addCriterion("caller_contract_address in", values, "callerContractAddress");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressNotIn(List<String> values) {
            addCriterion("caller_contract_address not in", values, "callerContractAddress");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressBetween(String value1, String value2) {
            addCriterion("caller_contract_address between", value1, value2, "callerContractAddress");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressNotBetween(String value1, String value2) {
            addCriterion("caller_contract_address not between", value1, value2, "callerContractAddress");
            return (Criteria)this;
        }
		
			
		public Criteria andCallerContractAddressLike(String value) {
            addCriterion("caller_contract_address like", value, "callerContractAddress");
            return (Criteria)this;
        }

        public Criteria andCallerContractAddressNotLike(String value) {
            addCriterion("caller_contract_address not like", value, "callerContractAddress");
            return (Criteria)this;
        }
	            public Criteria andResultIsNull() {
            addCriterion("result is null");
            return (Criteria)this;
        }

        public Criteria andResultIsNotNull() {
            addCriterion("result is not null");
            return (Criteria)this;
        }

        public Criteria andResultEqualTo(String value) {
            addCriterion("result =", value, "result");
            return (Criteria)this;
        }

        public Criteria andResultNotEqualTo(String value) {
            addCriterion("result <>", value, "result");
            return (Criteria)this;
        }

        public Criteria andResultIn(List<String> values) {
            addCriterion("result in", values, "result");
            return (Criteria)this;
        }

        public Criteria andResultNotIn(List<String> values) {
            addCriterion("result not in", values, "result");
            return (Criteria)this;
        }

        public Criteria andResultBetween(String value1, String value2) {
            addCriterion("result between", value1, value2, "result");
            return (Criteria)this;
        }

        public Criteria andResultNotBetween(String value1, String value2) {
            addCriterion("result not between", value1, value2, "result");
            return (Criteria)this;
        }
		
			
		public Criteria andResultLike(String value) {
            addCriterion("result like", value, "result");
            return (Criteria)this;
        }

        public Criteria andResultNotLike(String value) {
            addCriterion("result not like", value, "result");
            return (Criteria)this;
        }
	            public Criteria andTransactionIdIsNull() {
            addCriterion("transaction_id is null");
            return (Criteria)this;
        }

        public Criteria andTransactionIdIsNotNull() {
            addCriterion("transaction_id is not null");
            return (Criteria)this;
        }

        public Criteria andTransactionIdEqualTo(String value) {
            addCriterion("transaction_id =", value, "transactionId");
            return (Criteria)this;
        }

        public Criteria andTransactionIdNotEqualTo(String value) {
            addCriterion("transaction_id <>", value, "transactionId");
            return (Criteria)this;
        }

        public Criteria andTransactionIdIn(List<String> values) {
            addCriterion("transaction_id in", values, "transactionId");
            return (Criteria)this;
        }

        public Criteria andTransactionIdNotIn(List<String> values) {
            addCriterion("transaction_id not in", values, "transactionId");
            return (Criteria)this;
        }

        public Criteria andTransactionIdBetween(String value1, String value2) {
            addCriterion("transaction_id between", value1, value2, "transactionId");
            return (Criteria)this;
        }

        public Criteria andTransactionIdNotBetween(String value1, String value2) {
            addCriterion("transaction_id not between", value1, value2, "transactionId");
            return (Criteria)this;
        }
		
			
		public Criteria andTransactionIdLike(String value) {
            addCriterion("transaction_id like", value, "transactionId");
            return (Criteria)this;
        }

        public Criteria andTransactionIdNotLike(String value) {
            addCriterion("transaction_id not like", value, "transactionId");
            return (Criteria)this;
        }
	            public Criteria andResultTypeIsNull() {
            addCriterion("result_type is null");
            return (Criteria)this;
        }

        public Criteria andResultTypeIsNotNull() {
            addCriterion("result_type is not null");
            return (Criteria)this;
        }

        public Criteria andResultTypeEqualTo(String value) {
            addCriterion("result_type =", value, "resultType");
            return (Criteria)this;
        }

        public Criteria andResultTypeNotEqualTo(String value) {
            addCriterion("result_type <>", value, "resultType");
            return (Criteria)this;
        }

        public Criteria andResultTypeIn(List<String> values) {
            addCriterion("result_type in", values, "resultType");
            return (Criteria)this;
        }

        public Criteria andResultTypeNotIn(List<String> values) {
            addCriterion("result_type not in", values, "resultType");
            return (Criteria)this;
        }

        public Criteria andResultTypeBetween(String value1, String value2) {
            addCriterion("result_type between", value1, value2, "resultType");
            return (Criteria)this;
        }

        public Criteria andResultTypeNotBetween(String value1, String value2) {
            addCriterion("result_type not between", value1, value2, "resultType");
            return (Criteria)this;
        }
		
			
		public Criteria andResultTypeLike(String value) {
            addCriterion("result_type like", value, "resultType");
            return (Criteria)this;
        }

        public Criteria andResultTypeNotLike(String value) {
            addCriterion("result_type not like", value, "resultType");
            return (Criteria)this;
        }
	            public Criteria andBlockTimestampIsNull() {
            addCriterion("block_timestamp is null");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampIsNotNull() {
            addCriterion("block_timestamp is not null");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampEqualTo(Long value) {
            addCriterion("block_timestamp =", value, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampNotEqualTo(Long value) {
            addCriterion("block_timestamp <>", value, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampIn(List<Long> values) {
            addCriterion("block_timestamp in", values, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampNotIn(List<Long> values) {
            addCriterion("block_timestamp not in", values, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampBetween(Long value1, Long value2) {
            addCriterion("block_timestamp between", value1, value2, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampNotBetween(Long value1, Long value2) {
            addCriterion("block_timestamp not between", value1, value2, "blockTimestamp");
            return (Criteria)this;
        }
		
		public Criteria andBlockTimestampGreaterThan(Long value) {
            addCriterion("block_timestamp >", value, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampGreaterThanOrEqualTo(Long value) {
            addCriterion("block_timestamp >=", value, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampLessThan(Long value) {
            addCriterion("block_timestamp <", value, "blockTimestamp");
            return (Criteria)this;
        }

        public Criteria andBlockTimestampLessThanOrEqualTo(Long value) {
            addCriterion("block_timestamp <=", value, "blockTimestamp");
            return (Criteria)this;
        }
			
	            public Criteria andBlockNumberIsNull() {
            addCriterion("block_number is null");
            return (Criteria)this;
        }

        public Criteria andBlockNumberIsNotNull() {
            addCriterion("block_number is not null");
            return (Criteria)this;
        }

        public Criteria andBlockNumberEqualTo(Integer value) {
            addCriterion("block_number =", value, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberNotEqualTo(Integer value) {
            addCriterion("block_number <>", value, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberIn(List<Integer> values) {
            addCriterion("block_number in", values, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberNotIn(List<Integer> values) {
            addCriterion("block_number not in", values, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberBetween(Integer value1, Integer value2) {
            addCriterion("block_number between", value1, value2, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberNotBetween(Integer value1, Integer value2) {
            addCriterion("block_number not between", value1, value2, "blockNumber");
            return (Criteria)this;
        }
		
		public Criteria andBlockNumberGreaterThan(Integer value) {
            addCriterion("block_number >", value, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberGreaterThanOrEqualTo(Integer value) {
            addCriterion("block_number >=", value, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberLessThan(Integer value) {
            addCriterion("block_number <", value, "blockNumber");
            return (Criteria)this;
        }

        public Criteria andBlockNumberLessThanOrEqualTo(Integer value) {
            addCriterion("block_number <=", value, "blockNumber");
            return (Criteria)this;
        }
			
	            public Criteria andEventNameIsNull() {
            addCriterion("event_name is null");
            return (Criteria)this;
        }

        public Criteria andEventNameIsNotNull() {
            addCriterion("event_name is not null");
            return (Criteria)this;
        }

        public Criteria andEventNameEqualTo(String value) {
            addCriterion("event_name =", value, "eventName");
            return (Criteria)this;
        }

        public Criteria andEventNameNotEqualTo(String value) {
            addCriterion("event_name <>", value, "eventName");
            return (Criteria)this;
        }

        public Criteria andEventNameIn(List<String> values) {
            addCriterion("event_name in", values, "eventName");
            return (Criteria)this;
        }

        public Criteria andEventNameNotIn(List<String> values) {
            addCriterion("event_name not in", values, "eventName");
            return (Criteria)this;
        }

        public Criteria andEventNameBetween(String value1, String value2) {
            addCriterion("event_name between", value1, value2, "eventName");
            return (Criteria)this;
        }

        public Criteria andEventNameNotBetween(String value1, String value2) {
            addCriterion("event_name not between", value1, value2, "eventName");
            return (Criteria)this;
        }
		
			
		public Criteria andEventNameLike(String value) {
            addCriterion("event_name like", value, "eventName");
            return (Criteria)this;
        }

        public Criteria andEventNameNotLike(String value) {
            addCriterion("event_name not like", value, "eventName");
            return (Criteria)this;
        }
	            public Criteria andContractAddressIsNull() {
            addCriterion("contract_address is null");
            return (Criteria)this;
        }

        public Criteria andContractAddressIsNotNull() {
            addCriterion("contract_address is not null");
            return (Criteria)this;
        }

        public Criteria andContractAddressEqualTo(String value) {
            addCriterion("contract_address =", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotEqualTo(String value) {
            addCriterion("contract_address <>", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressIn(List<String> values) {
            addCriterion("contract_address in", values, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotIn(List<String> values) {
            addCriterion("contract_address not in", values, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressBetween(String value1, String value2) {
            addCriterion("contract_address between", value1, value2, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotBetween(String value1, String value2) {
            addCriterion("contract_address not between", value1, value2, "contractAddress");
            return (Criteria)this;
        }
		
			
		public Criteria andContractAddressLike(String value) {
            addCriterion("contract_address like", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotLike(String value) {
            addCriterion("contract_address not like", value, "contractAddress");
            return (Criteria)this;
        }
	            public Criteria andEventIndexIsNull() {
            addCriterion("event_index is null");
            return (Criteria)this;
        }

        public Criteria andEventIndexIsNotNull() {
            addCriterion("event_index is not null");
            return (Criteria)this;
        }

        public Criteria andEventIndexEqualTo(Integer value) {
            addCriterion("event_index =", value, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexNotEqualTo(Integer value) {
            addCriterion("event_index <>", value, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexIn(List<Integer> values) {
            addCriterion("event_index in", values, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexNotIn(List<Integer> values) {
            addCriterion("event_index not in", values, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexBetween(Integer value1, Integer value2) {
            addCriterion("event_index between", value1, value2, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexNotBetween(Integer value1, Integer value2) {
            addCriterion("event_index not between", value1, value2, "eventIndex");
            return (Criteria)this;
        }
		
		public Criteria andEventIndexGreaterThan(Integer value) {
            addCriterion("event_index >", value, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexGreaterThanOrEqualTo(Integer value) {
            addCriterion("event_index >=", value, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexLessThan(Integer value) {
            addCriterion("event_index <", value, "eventIndex");
            return (Criteria)this;
        }

        public Criteria andEventIndexLessThanOrEqualTo(Integer value) {
            addCriterion("event_index <=", value, "eventIndex");
            return (Criteria)this;
        }
			
	    	public Criteria andFieldIsNull(final String fieldName) {
            addCriterion(fieldName + " is null");
            return (Criteria) this;
        }
		
	public Criteria andFieldIsNotNull(final String fieldName) {
            addCriterion(fieldName + " is not null");
            return (Criteria) this;
        }
		
	public Criteria andFieldEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " = ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <> ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " in ", values, fieldName);
           return (Criteria) this;
        }
		
	public Criteria andFieldNotIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " not in ", values, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + " between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + "  not between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldGreaterThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " > ", fieldValue, fieldName);
            return (Criteria) this;
        }

	public Criteria andFieldGreaterThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " >= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLessThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " < ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldLessThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + " like ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + "  not like ", fieldValue, fieldName);
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}
